window.Gleam.initSearch([{"doc":"nessie","title":"nessie","content":"# nessie\n\n[![Package Version](https://img.shields.io/hexpm/v/nessie)](https://hex.pm/packages/nessie)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/nessie/)\n\nA friendly DNS client for Gleam programs targeting Erlang.\n\n```sh\ngleam add nessie\n```\n\n```gleam\nimport nessie\nimport gleam/io\n\npub fn main() {\n  let ipv4_addrs = nessie.lookup_ipv4(&quot;gleam.run&quot;, nessie.In, [])\n  io.debug(ipv4_addrs)\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/nessie&gt;.\n\n## Supported DNS Records\n\nThe following is a list of supported DNS record types. If\nnessie doesn&#39;t currently support a DNS record type you want, feel free to contribute\nto this project!\n\n- [x] A\n- [x] AAAA\n- [x] TXT\n- [x] CNAME\n- [x] MX\n- [x] SOA\n- [x] NS\n- [ ] PTR\n- [ ] SRV\n- [ ] CERT\n- [ ] DCHID\n- [ ] DNAME\n- [ ] DNSKEY\n- [ ] DS\n\n## What about JavaScript support?\n\nDue to Erlang and JavaScript&#39;s fundamentally different approaches\nto asynchronous programming (processes &amp; event loops, respectively),\nit&#39;s not currently possible in Gleam to write a DNS client supporting\nboth targets.\n\nFor more information, see [this Discord thread](https://discord.com/channels/768594524158427167/1224351163797868575). \n\n## Development\n\n```sh\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"nessie","title":"DnsClass","content":"pub type DnsClass {\n  In\n  Chaos\n  Hs\n  Any\n}\n A DNS class type.\nIn\n\n\nChaos\n\n\nHs\n\n\nAny\n\n\nSynonyms:\nnessie.DnsClass\nnessie DnsClass","url":"nessie.html#DnsClass"},{"doc":"nessie","title":"ErrorReason","content":"pub type ErrorReason {\n  Formerr\n  Qfmterr\n  Servfail\n  Nxdomain\n  Notimp\n  Refused\n  Badvers\n  TimeoutErr\n  Other(error: String)\n}\n A DNS error.\nFormerr\n\n\nQfmterr\n\n\nServfail\n\n\nNxdomain\n\n\nNotimp\n\n\nRefused\n\n\nBadvers\n\n\nTimeoutErr\n\n\nOther(error: String)\n Encapuslates any other error, such as Posix errors.\n\nSynonyms:\nnessie.ErrorReason\nnessie ErrorReason","url":"nessie.html#ErrorReason"},{"doc":"nessie","title":"Hostent","content":"pub type Hostent(addr) {\n  Hostent(\n    name: String,\n    aliases: List(String),\n    addrtype: String,\n    length: Int,\n    addr_list: List(addr),\n  )\n}\n A host entry.\n\n For more information, see the [`inet_res:hostent`](https://www.erlang.org/doc/man/inet#type-hostent) Erlang type.\nHostent(\n  name: String,\n  aliases: List(String),\n  addrtype: String,\n  length: Int,\n  addr_list: List(addr),\n)\n\n\nSynonyms:\nnessie.Hostent\nnessie Hostent","url":"nessie.html#Hostent"},{"doc":"nessie","title":"IPAddress","content":"pub type IPAddress {\n  IPV4(IPV4)\n  IPV6(IPV6)\n}\n A union type for IPv4 and IPv6 addresses.\nIPV4(IPV4)\n\n\nIPV6(IPV6)\n\n\nSynonyms:\nnessie.IPAddress\nnessie IPAddress","url":"nessie.html#IPAddress"},{"doc":"nessie","title":"IPV4","content":"pub type IPV4 =\n  #(Int, Int, Int, Int)\n Erlang representation of an IPv4 address.\n\nSynonyms:\nnessie.IPV4\nnessie IPV4","url":"nessie.html#IPV4"},{"doc":"nessie","title":"IPV6","content":"pub type IPV6 =\n  #(Int, Int, Int, Int, Int, Int, Int, Int)\n Erlang representation of an IPv6 address.\n\nSynonyms:\nnessie.IPV6\nnessie IPV6","url":"nessie.html#IPV6"},{"doc":"nessie","title":"MXRecord","content":"pub type MXRecord {\n  MXRecord(priority: Int, exchange: String)\n}\n A DNS MX record.\nMXRecord(priority: Int, exchange: String)\n\n\nSynonyms:\nnessie.MXRecord\nnessie MXRecord","url":"nessie.html#MXRecord"},{"doc":"nessie","title":"Nameserver","content":"pub type Nameserver =\n  #(IPAddress, Int)\n Nameserver address and port.\n\nSynonyms:\nnessie.Nameserver\nnessie Nameserver","url":"nessie.html#Nameserver"},{"doc":"nessie","title":"ResolverOption","content":"pub type ResolverOption {\n  Nameservers(opt: List(Nameserver))\n  INet6(opt: Bool)\n  Recurse(opt: Bool)\n  Retry(opt: Int)\n  TimeoutMillis(opt: Int)\n  NxdomainReply(opt: Bool)\n}\n Options for resolving a DNS name.\nNameservers(opt: List(Nameserver))\n\n\nINet6(opt: Bool)\n\n\nRecurse(opt: Bool)\n\n\nRetry(opt: Int)\n\n\nTimeoutMillis(opt: Int)\n\n\nNxdomainReply(opt: Bool)\n\n\nSynonyms:\nnessie.ResolverOption\nnessie ResolverOption","url":"nessie.html#ResolverOption"},{"doc":"nessie","title":"SOARecord","content":"pub type SOARecord {\n  SOARecord(\n    mname: String,\n    rname: String,\n    serial: Int,\n    refresh: Int,\n    retry: Int,\n    expire: Int,\n    minimum: Int,\n  )\n}\n A DNS SOA record.\nSOARecord(\n  mname: String,\n  rname: String,\n  serial: Int,\n  refresh: Int,\n  retry: Int,\n  expire: Int,\n  minimum: Int,\n)\n\n\nSynonyms:\nnessie.SOARecord\nnessie SOARecord","url":"nessie.html#SOARecord"},{"doc":"nessie","title":"StringRecordType","content":"pub type StringRecordType {\n  CNAME\n  TXT\n  NS\n}\n DNS record types returning plain string data.\nCNAME\n\n\nTXT\n\n\nNS\n\n\nSynonyms:\nnessie.StringRecordType\nnessie StringRecordType","url":"nessie.html#StringRecordType"},{"doc":"nessie","title":"Timeout","content":"pub type Timeout {\n  Timeout(value: Int)\n  Infinity\n}\n A timeout for DNS lookups.\nTimeout(value: Int)\n\n\nInfinity\n\n\nSynonyms:\nnessie.Timeout\nnessie Timeout","url":"nessie.html#Timeout"},{"doc":"nessie","title":"getbyname","content":"pub fn getbyname(\n  name: String,\n  srt: StringRecordType,\n  timeout: Timeout,\n) -&gt; Result(Hostent(String), ErrorReason)\n Looks up a DNS record of the given type for the given name.\nSynonyms:\nnessie.getbyname\nnessie getbyname","url":"nessie.html#getbyname"},{"doc":"nessie","title":"getbyname_ipv4","content":"pub fn getbyname_ipv4(\n  name: String,\n  timeout: Timeout,\n) -&gt; Result(Hostent(#(Int, Int, Int, Int)), ErrorReason)\n Looks up an `A` record for the given name.\nSynonyms:\nnessie.getbyname_ipv4\nnessie getbyname_ipv4","url":"nessie.html#getbyname_ipv4"},{"doc":"nessie","title":"getbyname_ipv6","content":"pub fn getbyname_ipv6(\n  name: String,\n  timeout: Timeout,\n) -&gt; Result(\n  Hostent(#(Int, Int, Int, Int, Int, Int, Int, Int)),\n  ErrorReason,\n)\n Looks up an `AAAA` record for the given name.\nSynonyms:\nnessie.getbyname_ipv6\nnessie getbyname_ipv6","url":"nessie.html#getbyname_ipv6"},{"doc":"nessie","title":"getbyname_mx","content":"pub fn getbyname_mx(\n  name: String,\n  timeout: Timeout,\n) -&gt; Result(Hostent(MXRecord), ErrorReason)\n Looks up a DNS MX record for the given name.\nSynonyms:\nnessie.getbyname_mx\nnessie getbyname_mx","url":"nessie.html#getbyname_mx"},{"doc":"nessie","title":"getbyname_soa","content":"pub fn getbyname_soa(\n  name: String,\n  timeout: Timeout,\n) -&gt; Result(Hostent(SOARecord), ErrorReason)\n Looks up a SOA record for the given name.\nSynonyms:\nnessie.getbyname_soa\nnessie getbyname_soa","url":"nessie.html#getbyname_soa"},{"doc":"nessie","title":"gethostbyaddr","content":"pub fn gethostbyaddr(\n  address: IPAddress,\n  timeout: Timeout,\n) -&gt; Result(Hostent(String), ErrorReason)\n Looks up a host by IP address.\nSynonyms:\nnessie.gethostbyaddr\nnessie gethostbyaddr","url":"nessie.html#gethostbyaddr"},{"doc":"nessie","title":"ip_decoder","content":"pub fn ip_decoder() -&gt; fn(Dynamic) -&gt;\n  Result(IPAddress, List(DecodeError))\n Returns a `gleam/dynamic.Decoder` for decoding an IP address tuple.\nSynonyms:\nnessie.ip_decoder\nnessie ip_decoder","url":"nessie.html#ip_decoder"},{"doc":"nessie","title":"ip_to_string","content":"pub fn ip_to_string(ip_addr: IPAddress) -&gt; Result(String, String)\n Converts an IP address to a string.\n\n For more detail, see the `inet` module&#39;s [ntoa/1 function docs](https://www.erlang.org/doc/man/inet#ntoa-1)\nSynonyms:\nnessie.ip_to_string\nnessie ip_to_string","url":"nessie.html#ip_to_string"},{"doc":"nessie","title":"lookup","content":"pub fn lookup(\n  name: String,\n  class: DnsClass,\n  srt: StringRecordType,\n  options: List(ResolverOption),\n) -&gt; List(String)\n Looks up a record of the specified type for the given name.\nSynonyms:\nnessie.lookup\nnessie lookup","url":"nessie.html#lookup"},{"doc":"nessie","title":"lookup_ipv4","content":"pub fn lookup_ipv4(\n  name: String,\n  class: DnsClass,\n  options: List(ResolverOption),\n) -&gt; List(#(Int, Int, Int, Int))\n Looks up an `A` record for the given name.\nSynonyms:\nnessie.lookup_ipv4\nnessie lookup_ipv4","url":"nessie.html#lookup_ipv4"},{"doc":"nessie","title":"lookup_ipv6","content":"pub fn lookup_ipv6(\n  name: String,\n  class: DnsClass,\n  options: List(ResolverOption),\n) -&gt; List(#(Int, Int, Int, Int, Int, Int, Int, Int))\n Looks up an `AAAA` record for the given name.\nSynonyms:\nnessie.lookup_ipv6\nnessie lookup_ipv6","url":"nessie.html#lookup_ipv6"},{"doc":"nessie","title":"lookup_mx","content":"pub fn lookup_mx(\n  name: String,\n  class: DnsClass,\n  options: List(ResolverOption),\n) -&gt; List(MXRecord)\n\nSynonyms:\nnessie.lookup_mx\nnessie lookup_mx","url":"nessie.html#lookup_mx"},{"doc":"nessie","title":"lookup_soa","content":"pub fn lookup_soa(\n  name: String,\n  class: DnsClass,\n  options: List(ResolverOption),\n) -&gt; List(SOARecord)\n Looks up a SOA record for the given name.\nSynonyms:\nnessie.lookup_soa\nnessie lookup_soa","url":"nessie.html#lookup_soa"},{"doc":"nessie","title":"string_to_ip","content":"pub fn string_to_ip(ip_addr: String) -&gt; Result(IPAddress, String)\n Converts a string to an IP address.\n\n If the given string is not a valid IP address, this function returns an error.\n\n For more detail, see the `inet` module&#39;s [parse_address/1 function docs](https://www.erlang.org/doc/man/inet#parse_address-1).\nSynonyms:\nnessie.string_to_ip\nnessie string_to_ip","url":"nessie.html#string_to_ip"},{"doc":"nessie","title":"nessie","content":" A collection of functions for resolving DNS names in Gleam programs targeting Erlang.\n\n The functions in this module are implemented using Erlang&#39;s built-in\n `inet_res` and `inet` modules. Most of the functions and types are simply\n Gleam representations of their Erlang counterparts.","url":"nessie.html"}]);